<?php

namespace Drupal\course\Plugin\course\CourseObject;

use Drupal\Core\Entity\EntityInterface;
use Drupal\course\Entity\CourseObjectInterface;

/**
 * Interface for course objects that reference other entities.
 */
interface CourseObjectEntityInterface extends CourseObjectInterface {

  /**
   * Return the entity type this object is representing.
   *
   * @return string
   */
  public function getInstanceEntityType(): string;

  /**
   * Return the entity this object is representing.
   *
   * @return \Drupal\Core\Entity\EntityInterface
   */
  function getInstanceEntity(): ?EntityInterface;

}
